"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Connection {
    constructor(config) {
        this.config = config;
        this.logger = this.config.getLogger();
    }
    /**
     * Begins a transaction (if supported)
     */
    async beginTransaction(savepoint) {
        throw new Error(`Transactions are not supported by current driver`);
    }
    /**
     * Commits statements in a transaction
     */
    async commit(savepoint) {
        throw new Error(`Transactions are not supported by current driver`);
    }
    /**
     * Rollback changes in a transaction
     */
    async rollback(savepoint) {
        throw new Error(`Transactions are not supported by current driver`);
    }
    logQuery(query) {
        this.logger.debug(`[query-logger] ${query}`);
    }
}
exports.Connection = Connection;
