import { Database } from 'sqlite';
import { Connection, QueryResult } from './Connection';
export declare class SqliteConnection extends Connection {
    private connection;
    connect(): Promise<void>;
    close(force?: boolean): Promise<void>;
    isConnected(): Promise<boolean>;
    beginTransaction(savepoint?: string): Promise<void>;
    commit(savepoint?: string): Promise<void>;
    rollback(savepoint?: string): Promise<void>;
    getDefaultClientUrl(): string;
    execute(query: string, params?: any[], method?: 'all' | 'get' | 'run'): Promise<QueryResult | any | any[]>;
    loadFile(path: string): Promise<void>;
    private transformResult;
}
export declare type SqliteDatabase = Database & {
    driver: {
        open: boolean;
    };
};
