"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const utils_1 = require("../utils");
const entity_1 = require("../entity");
function ManyToMany(options) {
    return function (target, propertyName) {
        const entity = target.constructor.name;
        const meta = metadata_1.MetadataStorage.getMetadata(entity);
        utils_1.Utils.lookupPathFromDecorator(meta);
        if (!options.entity) {
            throw new Error(`'@ManyToMany({ entity: string | Function })' is required in '${target.constructor.name}.${propertyName}'`);
        }
        const property = { name: propertyName, reference: entity_1.ReferenceType.MANY_TO_MANY, owner: !!options.inversedBy, cascade: [entity_1.Cascade.PERSIST] };
        meta.properties[propertyName] = Object.assign(property, options);
    };
}
exports.ManyToMany = ManyToMany;
