"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const utils_1 = require("../utils");
const entity_1 = require("../entity");
function ManyToOne(options = {}) {
    return function (target, propertyName) {
        const meta = metadata_1.MetadataStorage.getMetadata(target.constructor.name);
        utils_1.Utils.lookupPathFromDecorator(meta);
        const property = { name: propertyName, reference: entity_1.ReferenceType.MANY_TO_ONE, cascade: [entity_1.Cascade.PERSIST] };
        meta.properties[propertyName] = Object.assign(property, options);
    };
}
exports.ManyToOne = ManyToOne;
