"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const utils_1 = require("../utils");
const entity_1 = require("../entity");
function OneToMany(options) {
    return function (target, propertyName) {
        const meta = metadata_1.MetadataStorage.getMetadata(target.constructor.name);
        utils_1.Utils.lookupPathFromDecorator(meta);
        if (!options.entity) {
            throw new Error(`'@OneToMany({ entity: string | Function })' is required in '${target.constructor.name}.${propertyName}'`);
        }
        const property = { name: propertyName, reference: entity_1.ReferenceType.ONE_TO_MANY, cascade: [entity_1.Cascade.PERSIST] };
        meta.properties[propertyName] = Object.assign(property, options);
    };
}
exports.OneToMany = OneToMany;
