"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const naming_strategy_1 = require("../naming-strategy");
const SqliteConnection_1 = require("../connections/SqliteConnection");
const AbstractSqlDriver_1 = require("./AbstractSqlDriver");
class SqliteDriver extends AbstractSqlDriver_1.AbstractSqlDriver {
    constructor() {
        super(...arguments);
        this.connection = new SqliteConnection_1.SqliteConnection(this.config);
    }
    getConfig() {
        return {
            usesPivotTable: true,
            supportsTransactions: true,
            supportsSavePoints: true,
            namingStrategy: naming_strategy_1.UnderscoreNamingStrategy,
        };
    }
}
exports.SqliteDriver = SqliteDriver;
