import { EntityProperty, IEntity, IEntityType, IPrimaryKey } from '../decorators';
export declare class ArrayCollection<T extends IEntityType<T>> {
    readonly owner: IEntityType<any>;
    [k: number]: T;
    protected readonly items: T[];
    private _property;
    constructor(owner: IEntityType<any>, items?: T[]);
    getItems(): T[];
    toArray(parent?: IEntity): Record<string, any>[];
    getIdentifiers(field?: string): IPrimaryKey[];
    add(...items: T[]): void;
    set(items: T[]): void;
    remove(...items: T[]): void;
    removeAll(): void;
    contains(item: T): boolean;
    count(): number;
    readonly length: number;
    [Symbol.iterator](): IterableIterator<T>;
    protected handleInverseSide(item: T, method: string): void;
    protected readonly property: EntityProperty;
}
