import { IEntityType } from '../decorators';
import { ArrayCollection } from './ArrayCollection';
export declare class Collection<T extends IEntityType<T>> extends ArrayCollection<T> {
    private initialized;
    private dirty;
    private _populated;
    constructor(owner: IEntityType<any>, items?: T[], initialized?: boolean);
    getItems(): T[];
    add(...items: T[]): void;
    set(items: T[], initialize?: boolean): void;
    remove(...items: T[]): void;
    contains(item: T): boolean;
    count(): number;
    isInitialized(fully?: boolean): boolean;
    shouldPopulate(): boolean;
    populated(populated?: boolean): void;
    isDirty(): boolean;
    setDirty(dirty?: boolean): void;
    init(populate?: string[]): Promise<this>;
    private createCondition;
    private createManyToManyCondition;
    private modify;
    private checkInitialized;
    /**
     * re-orders items after searching with `$in` operator
     */
    private reorderItems;
}
