import { Configuration } from '../utils';
import { EntityData, EntityName, IEntityType, IPrimaryKey } from '../decorators';
import { UnitOfWork } from '../unit-of-work';
import { IDatabaseDriver } from '..';
export declare const SCALAR_TYPES: string[];
export declare class EntityFactory {
    private readonly unitOfWork;
    private readonly driver;
    private readonly config;
    private readonly metadata;
    private readonly hydrator;
    constructor(unitOfWork: UnitOfWork, driver: IDatabaseDriver, config: Configuration);
    create<T extends IEntityType<T>>(entityName: EntityName<T>, data: EntityData<T>, initialized?: boolean): T;
    private createEntity;
    createReference<T extends IEntityType<T>>(entityName: EntityName<T>, id: IPrimaryKey): T;
    /**
     * returns parameters for entity constructor, creating references from plain ids
     */
    private extractConstructorParams;
}
