import { IEntityType } from '../decorators';
import { EntityManager } from '../EntityManager';
export declare class EntityLoader {
    private readonly em;
    private readonly metadata;
    private readonly driver;
    constructor(em: EntityManager);
    populate<T extends IEntityType<T>>(entityName: string, entities: IEntityType<T>[], populate: string[], validate?: boolean): Promise<void>;
    /**
     * preload everything in one call (this will update already existing references in IM)
     */
    private populateMany;
    private initializeCollections;
    private initializeOneToMany;
    private initializeManyToMany;
    private findChildren;
    private populateField;
    private findChildrenFromPivotTable;
    private getChildReferences;
    private filterCollections;
}
