import { IDatabaseDriver } from '..';
import { EntityData, EntityMetadata, EntityProperty, IEntityType } from '../decorators';
import { EntityFactory } from '../entity';
export declare abstract class Hydrator {
    protected readonly factory: EntityFactory;
    protected readonly driver: IDatabaseDriver;
    constructor(factory: EntityFactory, driver: IDatabaseDriver);
    hydrate<T extends IEntityType<T>>(entity: T, meta: EntityMetadata, data: EntityData<T>): void;
    protected abstract hydrateProperty<T extends IEntityType<T>>(entity: T, prop: EntityProperty, value: EntityData<T>[any]): void;
}
