import { EntityMetadata } from '../decorators';
import { EntityManager } from '../EntityManager';
import { Configuration, Logger } from '../utils';
export declare class MetadataDiscovery {
    private readonly em;
    private readonly config;
    private readonly logger;
    private readonly metadata;
    private readonly namingStrategy;
    private readonly metadataProvider;
    private readonly cache;
    private readonly validator;
    private readonly discovered;
    constructor(em: EntityManager, config: Configuration, logger: Logger);
    discover(): Promise<Record<string, EntityMetadata>>;
    private discoverDirectory;
    private discoverEntity;
    private saveToCache;
    private applyNamingStrategy;
    private initFieldName;
    private initManyToManyFields;
    private initOneToManyFields;
    private processEntity;
    private definePivotTableEntities;
    private definePivotProperty;
    private getClassName;
    private defineBaseEntityProperties;
}
