import { EntityMetadata } from '../decorators';
import { Connection } from '../connections/Connection';
import { QueryOrder, QueryType } from './enums';
/**
 * SQL query builder
 */
export declare class QueryBuilder {
    private entityName;
    private metadata;
    private connection;
    type: QueryType;
    private aliasCounter;
    private flags;
    private _fields;
    private _populate;
    private _leftJoins;
    private _cond;
    private _data;
    private _orderBy;
    private _limit;
    private _offset;
    private readonly alias;
    private readonly helper;
    constructor(entityName: string, metadata: Record<string, EntityMetadata>, connection: Connection);
    select(fields: string | string[]): this;
    insert(data: any): this;
    update(data: any): this;
    delete(cond?: any): this;
    truncate(): this;
    count(field?: string, distinct?: boolean): this;
    where(cond: any): this;
    orderBy(orderBy: Record<string, QueryOrder>): this;
    populate(populate: string[]): this;
    limit(limit: number, offset?: number): this;
    offset(offset: number): this;
    getQuery(): string;
    getParams(): any[];
    execute(method?: string): Promise<any>;
    private prepareFields;
    private processWhere;
    private processCollection;
    private init;
    private getQueryBase;
}
