import { EntityMetadata } from '../decorators';
import { QueryOrder, QueryType } from './enums';
export declare class QueryBuilderHelper {
    private readonly entityName;
    private readonly alias;
    private readonly metadata;
    constructor(entityName: string, alias: string, metadata: Record<string, EntityMetadata>);
    getWhereParams(conditions: Record<string, any>): any[];
    wrap(field: string): string;
    mapper(type: QueryType, field: string, value?: any): string;
    processData(data: any): any;
    processJoins(leftJoins: Record<string, [string, string, string, string]>): string;
    mapJoinColumns(type: QueryType, join: [string, string, string, string]): string[];
    getTableName(entityName: string): string;
    getRegExpParam(re: RegExp): string;
    getQueryCondition(type: QueryType, cond: any): string[];
    getQueryOrder(type: QueryType, orderBy: Record<string, QueryOrder>, populate: Record<string, string>): string[];
    getQueryPagination(limit?: number, offset?: number): string;
    private processValue;
}
