import { IEntity } from '../decorators';
import { ChangeSet } from './ChangeSet';
import { EntityIdentifier, EntityValidator } from '../entity';
export declare class ChangeSetComputer {
    private readonly validator;
    private readonly originalEntityData;
    private readonly identifierMap;
    private readonly metadata;
    constructor(validator: EntityValidator, originalEntityData: Record<string, IEntity>, identifierMap: Record<string, EntityIdentifier>);
    computeChangeSet(entity: IEntity): ChangeSet | null;
    private computePayload;
    private processReference;
    private processManyToOne;
    private processManyToMany;
}
