import { EntityMetadata, IEntity, IEntityType, IPrimaryKey } from '../decorators';
export declare class Utils {
    static isObject<T = Record<string, any>>(o: any): o is T;
    static isString(s: any): s is string;
    static equals(a: any, b: any): boolean;
    static unique<T = string>(items: T[]): T[];
    static merge(target: any, ...sources: any[]): any;
    static diff(a: Record<string, any>, b: Record<string, any>): Record<string, any>;
    static diffEntities(a: IEntity, b: IEntity): Record<string, any>;
    static prepareEntity<T>(e: IEntityType<T>): Record<string, any>;
    static copy(entity: any): any;
    static renameKey(payload: any, from: string, to: string): void;
    static getParamNames(func: Function | string): string[];
    static isPrimaryKey(key: any): key is IPrimaryKey;
    static extractPK(data: any): IPrimaryKey | null;
    static isEntity<T = IEntity>(data: any): data is T;
    static isObjectID(key: any): boolean;
    static className(classOrName: string | Function): string;
    /**
     * uses some dark magic to get source path to caller where decorator is used
     */
    static lookupPathFromDecorator(meta: EntityMetadata): void;
    static getObjectType(value: any): string;
    static runSerial<T = any, U = any>(items: Iterable<U>, cb: (item: U) => Promise<T>): Promise<T[]>;
}
