import { EntityMetadata, EntityProperty, IEntity } from '../decorators';
export declare class ValidationError extends Error {
    constructor(message: string);
    static fromWrongPropertyType(entity: IEntity, property: string, expectedType: string, givenType: string, givenValue: string): ValidationError;
    static fromEntityInsteadOfIdentifier(entity: IEntity, type: string, field?: string): ValidationError;
    static fromCollectionNotInitialized(entity: IEntity, prop: EntityProperty): ValidationError;
    static fromMissingPrimaryKey(meta: EntityMetadata): ValidationError;
    static fromWrongReference(meta: EntityMetadata, prop: EntityProperty, key: keyof EntityProperty, owner?: EntityProperty): ValidationError;
    static fromWrongTypeDefinition(meta: EntityMetadata, prop: EntityProperty): ValidationError;
    static fromWrongOwnership(meta: EntityMetadata, prop: EntityProperty, key: keyof EntityProperty): ValidationError;
    static fromMissingOwnership(meta: EntityMetadata, prop: EntityProperty): ValidationError;
    private static fromMessage;
}
